# mypy-boto3-connect

[![PyPI - mypy-boto3-connect](https://img.shields.io/pypi/v/mypy-boto3-connect.svg?color=blue)](https://pypi.org/project/mypy-boto3-connect)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-connect.svg?color=blue)](https://pypi.org/project/mypy-boto3-connect)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-connect](#mypy-boto3-connect)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.Connect 1.13.25](https://boto3.amazonaws.com/v1/documentation/api/1.13.25/reference/services/connect.html#Connect) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-connect](#mypy-boto3-connect)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `Connect` service.

```bash
python -m pip install boto3-stubs[connect]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_connect` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_connect import ConnectClient

# Now mypy can check if your code is valid.
client: ConnectClient = boto3.client("connect")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: ConnectClient = session.client("connect")



# Annotated paginators are included as well

import mypy_boto3_connect.paginator as connect_paginators

get_metric_data_paginator: connect_paginators.GetMetricDataPaginator = client.get_paginator("get_metric_data")
list_contact_flows_paginator: connect_paginators.ListContactFlowsPaginator = client.get_paginator("list_contact_flows")
list_hours_of_operations_paginator: connect_paginators.ListHoursOfOperationsPaginator = client.get_paginator("list_hours_of_operations")
list_phone_numbers_paginator: connect_paginators.ListPhoneNumbersPaginator = client.get_paginator("list_phone_numbers")
list_queues_paginator: connect_paginators.ListQueuesPaginator = client.get_paginator("list_queues")
list_routing_profiles_paginator: connect_paginators.ListRoutingProfilesPaginator = client.get_paginator("list_routing_profiles")
list_security_profiles_paginator: connect_paginators.ListSecurityProfilesPaginator = client.get_paginator("list_security_profiles")
list_user_hierarchy_groups_paginator: connect_paginators.ListUserHierarchyGroupsPaginator = client.get_paginator("list_user_hierarchy_groups")
list_users_paginator: connect_paginators.ListUsersPaginator = client.get_paginator("list_users")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_connect` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_connect as connect
from mypy_boto3_connect import ConnectClient

# with these
from mypy_boto3 import connect
from mypy_boto3.connect import ConnectClient
```